"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InputArrayWrap = void 0;

var _react = _interopRequireWildcard(require("react"));

var _componentRender = require("../componentRender");

var _ducks = require("../ducks");

var _translation_utils = require("../../translation_utils");

var _deletedMark = require("../deletedMark");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

const handleAdd = dispatch => {
  dispatch(_ducks.inputArray.add());
};

const renderAddButton = ({
  onAdd,
  styles,
  Button,
  AddGlyph
}) => {
  const boundAdd = e => {
    e.preventDefault();
    onAdd();
  };

  return _react.default.createElement(Button, {
    onClick: boundAdd,
    styles: styles
  }, _react.default.createElement(AddGlyph, null));
};

const renderCloseButton = ({
  onRemove,
  idx,
  styles,
  Button,
  RemoveGlyph
}) => {
  const boundRemove = e => {
    e.preventDefault();
    onRemove(idx);
  };

  return _react.default.createElement(Button, {
    onClick: boundRemove,
    styles: styles
  }, _react.default.createElement(RemoveGlyph, null));
};

const renderPanelHeader = ({
  schemaTypeName,
  dispatch,
  name,
  styles,
  Button,
  AddGlyph
}) => {
  const addButton = renderAddButton({
    onAdd: handleAdd.bind(null, dispatch),
    styles,
    Button,
    AddGlyph
  });
  return _react.default.createElement("div", {
    className: styles.inputPanelWrap
  }, (0, _translation_utils.trModel)(schemaTypeName, name) + ' ', addButton);
};
/**
 * Used for the arrays in models, for
 * example clients: [Clients]
 *
 */


let InputArrayWrap = (_ref) => {
  let {
    name,
    newObject,
    arrayHandler,
    register,
    unregister,
    fieldSchema: {
      type
    },
    schemaTypeName,
    defaultValue,
    initiallyEmpty,
    onRemove,
    config,
    styles,
    isTable,
    setValue,
    skin
  } = _ref,
      rest = _objectWithoutProperties(_ref, ["name", "newObject", "arrayHandler", "register", "unregister", "fieldSchema", "schemaTypeName", "defaultValue", "initiallyEmpty", "onRemove", "config", "styles", "isTable", "setValue", "skin"]);

  const [items, dispatch] = (0, _react.useReducer)(_ducks.inputArray.reducer, _ducks.inputArray.initialFromDefault(defaultValue, initiallyEmpty));
  const registeredFields = (0, _react.useRef)({});
  const schema = type[0];
  const $arrayHandler = arrayHandler;
  const Button = skin.arrayButton.render;
  const AddGlyph = skin.addGlyph.render;
  const RemoveGlyph = skin.removeGlyph.render;
  const Panel = skin.panel.render;
  const itemsInputs = items.keys.map(idx => {
    if (idx === null) {
      return null;
    } else {
      const handleRemove = idx => {
        dispatch(_ducks.inputArray.remove(idx));
        const taint = `${name}[${idx}].${_deletedMark.deletedMark}`;
        setValue(taint, true);
      };

      const registerSpy = params => {
        if (params !== null) {
          const {
            name
          } = params;

          if (name) {
            const regFields = registeredFields.current;
            if (regFields[idx]) regFields[idx].add(name);else regFields[idx] = new Set([name]);
          }
        }

        return register(params);
      };

      const closeButton = renderCloseButton({
        onRemove: handleRemove,
        idx,
        styles,
        Button,
        RemoveGlyph
      });
      let itemDefault;
      if (defaultValue && Array.isArray(defaultValue)) itemDefault = defaultValue[idx];else itemDefault = defaultValue;
      return {
        idx,
        closeButton,
        inputs: (0, _componentRender.renderInputs)(_objectSpread({}, rest, {
          inline: isTable,
          schema,
          schemaTypeName,
          setValue,
          parent: name,
          index: idx,
          initialValues: itemDefault,
          styles,
          register: registerSpy,
          unregister,
          arrayIdx: idx,
          arrayInitialValues: itemDefault,
          skin
        }))
      };
    }
  }).filter(item => item !== null);
  const panelProps = {
    schemaTypeName,
    dispatch,
    name,
    styles,
    Button,
    AddGlyph
  };
  return _react.default.createElement(Panel, {
    header: renderPanelHeader(panelProps),
    styles: styles
  }, _react.default.createElement($arrayHandler, _extends({
    schema: schema,
    config: config,
    name: name,
    component: arrayHandler,
    onAdd: handleAdd.bind(null, dispatch),
    newObject: newObject,
    items: itemsInputs,
    defaultValue: defaultValue,
    schemaTypeName: schemaTypeName,
    styles: styles,
    skin: skin
  }, rest)));
};

exports.InputArrayWrap = InputArrayWrap;