"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InputWrap = void 0;

var _react = _interopRequireWildcard(require("react"));

var _translation_utils = require("../../translation_utils");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const Wrap = ({
  name,
  children,
  inline,
  styles,
  label
}) => {
  if (inline) {
    return _react.default.createElement("div", {
      key: name,
      className: styles.inlineWrap
    }, children);
  } else {
    return _react.default.createElement("div", {
      key: name,
      className: styles.inputBlockWrap
    }, _react.default.createElement("label", {
      key: "label",
      htmlFor: name,
      className: styles.label
    }, label), children);
  }
};

let InputWrap = (props, ref) => {
  const {
    name,
    field,
    children,
    schemaTypeName,
    styles,
    labelOverride,
    inline,
    errors = {}
  } = props;
  const label = typeof labelOverride != 'undefined' ? labelOverride : (0, _translation_utils.trField)(props);
  const error = errors[name];
  return _react.default.createElement(Wrap, {
    name: name,
    inline: inline,
    styles: styles,
    label: label
  }, children, error && _react.default.createElement(_react.default.Fragment, null, _react.default.createElement("div", {
    className: styles.error
  }, _react.default.createElement("div", {
    className: styles.errorMessage
  }, error.message), _react.default.createElement("div", {
    className: styles.errorIcon
  }, "\u274C"))));
};

exports.InputWrap = InputWrap;
exports.InputWrap = InputWrap = (0, _react.forwardRef)(InputWrap);