"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.reducer = exports.initialFromDefault = exports.initial = exports.initialEmpty = exports.add = exports.remove = exports.ADD = exports.REMOVE = void 0;

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) arr2[i] = arr[i]; return arr2; } }

const REMOVE = 'REMOVE';
exports.REMOVE = REMOVE;
const ADD = 'ADD';
exports.ADD = ADD;

const remove = idx => ({
  type: REMOVE,
  idx
});

exports.remove = remove;

const add = () => ({
  type: ADD
});

exports.add = add;
const initialEmpty = {
  last: 0,
  keys: []
};
exports.initialEmpty = initialEmpty;
const initial = {
  last: 1,
  keys: [0]
};
exports.initial = initial;

const initialFromDefault = (defaultValue, initiallyEmpty) => {
  if (defaultValue && Array.isArray(defaultValue)) {
    return {
      last: defaultValue.length,
      keys: defaultValue.map((_, idx) => idx)
    };
  } else {
    return initiallyEmpty ? initialEmpty : initial;
  }
};

exports.initialFromDefault = initialFromDefault;

const reducer = (state = initial, action) => {
  switch (action.type) {
    case REMOVE:
      const {
        keys
      } = state;
      return {
        last: state.last,
        keys: [].concat(_toConsumableArray(keys.slice(0, action.idx)), [null], _toConsumableArray(keys.slice(action.idx + 1)))
      };

    case ADD:
      return {
        last: state.last + 1,
        keys: [].concat(_toConsumableArray(state.keys), [state.last])
      };

    default:
      return state;
  }
};

exports.reducer = reducer;